package com.themes.fancy.keyboard.keyboard.myada;


import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.themes.fancy.keyboard.keyboard.R;
import com.themes.fancy.keyboard.keyboard.data.KbSource;
import com.themes.fancy.keyboard.keyboard.listener.OnClickCallback;
import com.themes.fancy.keyboard.keyboard.viewui.ApplyActivity;
import com.bumptech.glide.Glide;
import com.themes.fancy.keyboard.keyboard.helper.Common;

import java.util.ArrayList;
import java.util.List;

public class MainAdapter extends RecyclerView.Adapter<MainAdapter.ForYouViewHolder> {

    private Context mContext;
    private List<KbSource> mList = new ArrayList<>();

    private OnClickCallback mCallBack;

    public MainAdapter(Context context) {
        mContext = context;
    }

    public void setForYouList(List<KbSource> list) {
        this.mList = list;
        notifyDataSetChanged();
    }


    public void setClickAction(OnClickCallback callback) {
        mCallBack = callback;
    }

    @NonNull
    @Override
    public ForYouViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        View view = LayoutInflater.from(mContext).inflate(R.layout.item_home_layout, parent, false);
        return new ForYouViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ForYouViewHolder holder, int position) {
        KbSource kbSource = mList.get(position);
        String thumbGif = kbSource.getThumbGif();
        String thumb = kbSource.getThumbUrl();
        if (!thumbGif.isEmpty()) {
            Common.INSTANCE.loadWepJif(mContext, thumbGif, holder.itemImg);
        } else {
            Glide.with(mContext).load(thumb).into(holder.itemImg);
        }

        holder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intentApply = new Intent(mContext, ApplyActivity.class);
                intentApply.putExtra(ApplyActivity.SOURCE_KEY,kbSource);
                intentApply.putExtra(ApplyActivity.DISPLAY_URL_KEY, kbSource.getImgPath());
                intentApply.putExtra(ApplyActivity.ZIP_URL_KEY, kbSource.getZipPath());
                intentApply.putExtra(ApplyActivity.NAME_KEY, kbSource.getTitleName());
                intentApply.putExtra(ApplyActivity.GIF_KEY, kbSource.getImgGif());
                String intent_thumb;
                if (!thumbGif.isEmpty()) {
                    intent_thumb = thumbGif;
                } else {
                    intent_thumb = thumb;
                }
                intentApply.putExtra(ApplyActivity.THUMB_KEY, intent_thumb);
                mContext.startActivity(intentApply);
                if (mCallBack != null) {
                    mCallBack.OnItemClickListener();
                }

            }
        });


    }

    @Override
    public int getItemCount() {
        return mList.size();
    }

    public static class ForYouViewHolder extends RecyclerView.ViewHolder {

        private CardView cardView;
        private ImageView itemImg;

        public ForYouViewHolder(@NonNull View itemView) {
            super(itemView);
            cardView = itemView.findViewById(R.id.card_view);
            itemImg = itemView.findViewById(R.id.imPreview);

        }

    }

//    private void loadWepJif(String webpGifUrl,ImageView view){
//        Glide.with(mContext).load(webpGifUrl).addListener(new RequestListener<Drawable>() {
//            @Override
//            public boolean onLoadFailed(@Nullable GlideException e, @Nullable Object model, @NonNull Target<Drawable> target, boolean isFirstResource) {
//                return false;
//            }
//
//            @Override
//            public boolean onResourceReady(@NonNull Drawable resource, @NonNull Object model, Target<Drawable> target, @NonNull DataSource dataSource, boolean isFirstResource) {
//               if(resource instanceof WebpDrawable){
//                   WebpDrawable webpDrawable = (WebpDrawable) resource;
//                   webpDrawable.setLoopCount(LOOP_FOREVER);
//               }
//
//                return false;
//            }
//        }).into(view);
//    }
}
